// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var Filters = function () {
	
    var init = function() {
	
		this.filters = new Array();
	
		CONNECTOR.getFirstPhotoDate(function(firstdate) {
			
			min = Math.floor(firstdate.getTime() / 86400000)
			max = Math.ceil(new Date().getTime() / 86400000)
			
			filter = new DateRangeFilter('#date-range-filter', '#date-range-filter-value', min, max, min, max)
			filter.render();
			Filters.append(filter);
		})
		
	}
	
	var applyFilters = function() {
		for (i in Library.images) {
			this.applyFiltersToImage(Library.images[i]);
		}
		
		$(window).scroll()
		
	}
	
	var applyFiltersToImage = function(image) {
		
		display = true
		for (f in this.filters) {
		
			if ( !this.filters[f].testImage(image) ) {
				
				display = false
				break;
			}
			
		}
			
		if (display) {
			image.show()
		} else {
			image.hide()
		}
		
	}
	
	var append = function(filter) {
		this.filters.push(filter)
	}
	
	return {
		init: init,
		append: append,
		applyFilters: applyFilters,
		applyFiltersToImage: applyFiltersToImage
	}

}();