// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var FLICKR_API_KEY = "b68ebfeecf66c9c9ef845d49cdfbf38a";
var FLICKR_USER_ID = '51268276@N07'
var FLICKR_DEFAULT_SIZE = 's';

var FlickrApiConnector = function (api_key) {
	if (arguments.length > 0) {
    	this.init(api_key);
	}
};

FlickrApiConnector.prototype.init = function (api_key) {
	
	console.log("init FlickrApiConnector");
	console.log("API Key: " + FLICKR_API_KEY);
	
};

FlickrApiConnector.prototype.fetchImages = function(page, per_page, callback) {
	
	console.log('fetch Flickr images, page %s', page)
	
	var images = new Array();

	Main.onStartRequest();
	
	$.getJSON('http://www.flickr.com/services/rest/'
					+'?method=flickr.people.getPublicPhotos'
					+'&api_key=' + FLICKR_API_KEY
					+'&user_id=' + FLICKR_USER_ID 
					+'&per_page=' + per_page 
					+'&page=' + page 
					+'&extras=date_taken'
					+'&format=json&jsoncallback=?', function(data){
		
		CONNECTOR.total_pages = data.photos.pages
						
		$.each(data.photos.photo, function(i,item){
	    	
			callback(new FlickrImage(item.farm, item.server, item.id, item.secret, FLICKR_DEFAULT_SIZE, item.owner, item.datetaken));
	
		});
		
		Main.onFinishedRequest();
	});
	
}

FlickrApiConnector.prototype.getFirstPhotoDate = function(callback) {
	
	console.log('fetch first photo date')
	
	Main.onStartRequest();
	
	$.getJSON('http://www.flickr.com/services/rest/'
					+'?method=flickr.people.getInfo'
					+'&api_key=' + FLICKR_API_KEY
					+'&user_id=' + FLICKR_USER_ID 
					+'&format=json&jsoncallback=?', function(data){
						
		callback(Date.fromString(data.person.photos.firstdatetaken._content));
		
		Main.onFinishedRequest();
	});
	
}