// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var FlickrImage = function(farm, server, id, secret, size, owner, datetaken) {
	if (arguments.length > 0) {
		this.init(farm, server, id, secret, size, owner, datetaken);
	}
}

//Inheritance
FlickrImage.prototype = new Image();
FlickrImage.prototype.constructor = FlickrImage;
FlickrImage.superclass = Image.prototype;

FlickrImage.prototype.init = function(farm, server, id, secret, size, owner, datetaken) {
	
	//console.log('init FlickrImage');
	
	var uri = 'http://farm'+ farm + '.static.flickr.com/' + server + '/' + id + '_' + secret + '.jpg'
	FlickrImage.superclass.init.call(this, uri, id)
	
	this.farm = farm;
	this.server = server;
	this.secret = secret;
	this.size = size;
	this.owner = owner;
	this.datetaken = Date.fromString(datetaken);
	this.thumbnail = 'http://farm'+ farm + '.static.flickr.com/' + server + '/' + id + '_' + secret + '_'+ size +'.jpg'
	this.clickthrough = 'http://www.flickr.com/photos/'+ this.owner + '/' + this.id;
	
	//console.log('clickthrough: %s', this.clickthrough);
	
}

FlickrImage.prototype.toString = function() {
	
	return 'FlickrImage(' + this.uri + ')';
	
}