// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var LIBRARY_PER_PAGE = 15;

var Library = function () {
	
	var jQueryObject;
	var images = new Array();
	var current_page = -1;
		
	var init = function() {
		
		console.log("init Library");
		
		this.jQueryObject =  $('#library');
		this.fillLibrary();
		
		//console.log("setup infinite scroll")
		$(window).scroll(function() {Library.onScroll()});
	}
	
	var fillLibrary = function() {
		
		this.empty();
		this.fetchImages(1, LIBRARY_PER_PAGE);
		this.current_page = 1;
		
	}
	
	var fetchImages = function(page, per_page) {
		
		console.log("fetching images");
		
  		CONNECTOR.fetchImages(page, per_page, bind(this, this.appendToLibrary));

	}
	
	var appendToLibrary = function(image) {
		
		//console.log("Append image '%s' to library", image);
		
		this.jQueryObject.append('<a href="'+ image.clickthrough + '" rel="library"><img id="i'+ image.id +'" src="'+ image.thumbnail + '" /></a>');
		Filters.applyFiltersToImage(image);
		this.images.push(image);
		
		
	}
	
	var empty = function() {
		
		//console.log("empty library");
		
		this.images = new Array();
		this.jQueryObject.empty();
		
	}

	var onScroll = function() {
		
		if (this.current_page >= CONNECTOR.total_pages) { return; }
		
		offset = ( $('#library img:last').offset() == null ? $('#library') : $('#library img:last') ).offset().top // if no images are loaded, use library elt
		
		//console.log('onscroll: ' + (offset - $(window).height() - $(window).scrollTop()))
		
		if (offset - $(window).height() - $(window).scrollTop() <= 100) { // load more images if last image is less than 100px below view
	
			this.current_page = this.current_page + 1
			this.fetchImages(this.current_page, LIBRARY_PER_PAGE);
           
        }
	};

	return { // list public methods & variables
		init: init,
		fillLibrary: fillLibrary,
		fetchImages: fetchImages,
		appendToLibrary: appendToLibrary,
		empty: empty,
		onScroll: onScroll
	};
	
}();

