// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var Main = function () {
		
	var init = function() {
		
		console.log("init Main");
		
		CONNECTOR = new FlickrApiConnector();
		
		Library.init();
		Filters.init();
		$('#filters_trigger').click(Main.toggleFiltersPane)

	}
	
	var onStartRequest = function() {
		
   	 	$('#loader').html('<img src="images/loader.gif"/>');
		
	}
	
	var onFinishedRequest = function() {
	
    	$('#loader').empty();
		$(window).scroll(); // check if enough images are loaded

	}
	
 	var toggleFiltersPane = function(e) {
	
		//console.log('toggle filters pane');

		e.preventDefault();
		if ($("#library").css('left') == '250px') {
			//console.log('state = open, closing...')
			$("#library").animate({left:0}, 100, 'linear')
			$("#filters").hide(100, 'linear')
			$('#filters_trigger').html('Display filters!')
		} else {
			//console.log('state = clodes, opening...')
			$("#library").animate({left:250}, 100, 'linear')
			$("#filters").show(100, 'linear')
			$('#filters_trigger').html('Hide filters!')
		}
		
		window.setTimeout('$(window).scroll()', 150);
		return false;
	
	}
	
	return {
		init: init,
		onStartRequest: onStartRequest,
		onFinishedRequest: onFinishedRequest,
		toggleFiltersPane: toggleFiltersPane
	};
	
}();


function bind(scope, fn) {
    return function () {
        fn.apply(scope, arguments);
    };
}

function pad2(number) {
   
     return (number < 10 ? '0' : '') + number
   
}